<template>
  <div>
    <p class="text-xl font-semibold py-6 px-8 border-b">Word list</p>
    <div class="grid grid-cols-12">
      <div class="col-span-12 md:col-span-7 border-r flex flex-col min-h-[550px]">
        <div class="flex-grow">
          <div class="bg-slate-200 px-8 py-4">
            <CdxField>
              <CdxTextInput
                v-model="inputWords"
                clearable
                placeholder="Type here the word too record"
                @keydown.enter="addWords()"
              />
              <template #help-text>
                <p class="text-sm mb-1">
                  To differentiate between two homographs, specify the meaning in parentheses, for
                  example "son (relationship)" vs "son (plural of son)".
                </p>
                <p class="text-sm">
                  To add several words at once, separate them with #, for example
                  “big#house#orange”.
                </p>
              </template>
            </CdxField>
          </div>
          <div v-if="warning.length">
            <cdx-message type="warning" dismiss-button-label="Close">
              {{ warning }}
            </cdx-message>
          </div>
          <div v-if="isLoading" class="h-[60%] flex w-full items-center">
            <Loader />
          </div>
          <ItemList
            v-else
            :words="store.items"
            :primary-action="deleteWordAction"
            @primary="deleteWordAction.function"
          ></ItemList>
        </div>
        <div class="w-full grid grid-cols-3">
          <CdxButton
            action="destructive"
            size="large"
            :disabled="store.items.length == 0"
            class="col-span-2"
          >
            Remove word already recorded
          </CdxButton>
          <CdxButton
            action="destructive"
            size="large"
            weight="primary"
            :disabled="store.items.length == 0"
            @click="clearList()"
          >
            Clear
          </CdxButton>
        </div>
      </div>
      <div
        class="col-span-12 order-first md:order-last md:col-span-5 flex flex-col gap-5 py-6 px-8"
      >
        <p class="font-medium text-lg">Try out a word generator</p>
        <button
          class="border px-4 bg-gray-50 py-3 w-full justify-start flex gap-x-4 items-center"
          @click="isLocalListOpen = true"
        >
          <img src="/favicon.ico" class="w-8" />
          <span>Local List</span>
        </button>

        <GeneratorLocalListDialog
          v-model:open="isLocalListOpen"
          v-model:loading="isLoading"
          v-model:warning="warning"
          @can-go-to-next-step="emit('canGoToNextStep')"
        />

        <button
          class="border px-4 bg-gray-50 py-3 w-full justify-start flex gap-x-4 items-center"
          @click="nearbyOpen = true"
        >
          <img
            src="https://lingualibre.org/extensions/RecordWizard/icons/explore.svg?27b07"
            class="w-8"
          />
          <span>Nearby</span>
        </button>

        <GeneratorNearbyDialog
          v-model:open="nearbyOpen"
          @can-go-to-next-step="emit('canGoToNextStep')"
        />

        <button
          class="border px-4 bg-gray-50 py-3 w-full justify-start flex gap-x-4 items-center"
          @click="iswikimediaCategOpen = true"
        >
          <img
            src="https://lingualibre.org/extensions/RecordWizard/icons/wikipedia.svg?ea851"
            class="w-8"
            alt=""
          />
          <span>Wikimedia Category</span>
        </button>

        <GeneratorWikimediaCategoryDialog
          v-model:open="iswikimediaCategOpen"
          @can-go-to-next-step="emit('canGoToNextStep')"
        />

        <button
          class="border px-4 bg-gray-50 py-3 w-full justify-start flex gap-x-4 items-center"
          @click="isExternalToolsOpen = true"
        >
        <img
            src="https://upload.wikimedia.org/wikipedia/commons/thumb/1/1a/Wikidata_Query_Service_Favicon.svg/106px-Wikidata_Query_Service_Favicon.svg.png?20170921110529"
            class="w-8"
            alt=""
          />
          <span>External Tools</span>
        </button>

        <GeneratorExternalToolsDialog
          v-model:open="isExternalToolsOpen"
          @can-go-to-next-step="emit('canGoToNextStep')"
        />

        <button
          class="border px-4 bg-gray-50 py-3 w-full justify-start flex gap-x-4 items-center"
          @click="isWikidataLexemeToolsOpen = true"
        >
        <img
            src="/Wikidata_lexemes_logo_symbol_square.svg "
            class="w-8"
            alt=""
          />
          <span>Wikidata Lexeme</span>
        </button>

        <GeneratorWikidataLexemeDialog
          v-model:open="isWikidataLexemeToolsOpen"
          @can-go-to-next-step="emit('canGoToNextStep')"
        />

        <CdxButton
          v-if="!store.shareableListId"
          :disabled="!store.items.length"
          action="progressive"
          @click="createListLink"
        >
          Share List
        </CdxButton>
        <!-- <p class="text-xs -mt-2.5">
          You can only create new link after you clear the current list and add new words, yu can
          update current list by clicking on update list below
        </p> -->
        <p v-if="store.shareableListId" class="">
          {{ domainName }}/share/{{ store.shareableListId }}
          <CdxIcon
            :icon="cdxIconCopy"
            class="cursor-pointer ml-1"
            @click="copyToClipboard(`${domainName}/share/${store.shareableListId}`)"
          />
        </p>
        <div class="flex gap-x-3">
          <CdxButton
            v-if="store.items.length && store.shareableListId"
            action="progressive"
            class="w-full"
            @click="updateListLink"
          >
            Update link
          </CdxButton>
          <CdxButton
            v-if="store.items.length && store.shareableListId"
            action="progressive"
            class="w-full"
            @click="createListLink"
          >
            Create new link
          </CdxButton>
        </div>
        <p v-if="store.shareableListId" class="text-xs -mt-2">
          If you add words inside the list after clicking on share list, you can decide to either
          add those words within same link, or create a new link
        </p>
      </div>
    </div>
  </div>
</template>

<script setup>
import {
  CdxButton,
  CdxField,
  CdxTextInput,
  CdxIcon,
  CdxDialog,
  CdxToggleSwitch,
  CdxMessage,
} from '@wikimedia/codex'
import {
  cdxIconTrash,
  cdxIconLogoWikipedia,
  cdxIconMapPin,
  cdxIconCopy,
} from '@wikimedia/codex-icons'
import { ref, onMounted } from 'vue'
import { useRecordWizardStore } from '@/stores/recordwizard'
import ItemList from '@/components/ItemList.vue'
import GeneratorLocalListDialog from '@/components/Generators/LocalListDialog.vue'
import GeneratorNearbyDialog from '@/components/Generators/NearbyDialog.vue'
import GeneratorWikimediaCategoryDialog from '@/components/Generators/WikimediaCategoryDialog.vue'
import GeneratorExternalToolsDialog from '@/components/Generators/ExternalToolsDialog.vue'
import GeneratorWikidataLexemeDialog from '@/components/Generators/WikidataLexemeDialog.vue'
import makeApiCall from '@/utils/makeApiCall.js'
import Loader from '@/components/Loader.vue'
import VueCookies from 'vue-cookies'

const switchValue = ref(true)
const nearbyOpen = ref(false)
const iswikimediaCategOpen = ref(false)
const isExternalToolsOpen = ref(false)
const isLocalListOpen = ref(false)
const isLoading = ref(false)
const warning = ref('')
const emit = defineEmits(['canGoToNextStep', 'canNotGoToNextStep'])
const listCleared = ref(false)

const store = useRecordWizardStore()
const shareableListId = ref(null)
const domainName = ref('')

const inputWords = ref('')
const deleteWordAction = {
  label: 'Delete word',
  icon: cdxIconTrash,
  function: (word, index) => {
    store.items.splice(index, 1)
    if (!store.items.length) emit('canNotGoToNextStep')
  },
}

const clearList = function () {
  store.items = []
  warning.value = ''
  isLoading.value = false
  emit('canNotGoToNextStep')
}

const addWords = function () {
  if (inputWords.value.length === 0) {
    return
  }

  store.addWords(inputWords.value)

  inputWords.value = ''
  emit('canGoToNextStep')
}

const createListLink = async () => {
  const res = await makeApiCall(
    'post',
    `/locutors/my/${store.selectedLocutorId}/create-list`,
    () => {},
    true,
    {
      words: JSON.stringify(store.items),
      language_qid: store.selectedLanguageId,
    },
    {
      'X-CSRFToken': VueCookies.get('csrftoken'),
    },
  )
  store.shareableListId = res.id
}

const updateListLink = async () => {
  await makeApiCall(
    'put',
    `/locutors/my/${store.selectedLocutorId}/create-list/${store.shareableListId}`,
    () => {},
    true,
    {
      words: JSON.stringify(store.items),
      language_qid: store.selectedLanguageId,
    },
    {
      'X-CSRFToken': VueCookies.get('csrftoken'),
    },
  )
}

const copyToClipboard = (text) => {
  if (navigator.clipboard) {
    navigator.clipboard
      .writeText(text)
      .then(() => {
        alert('Link copied to clipboard!')
      })
      .catch((err) => {
        console.error('Failed to copy text: ', err)
      })
  } else {
    console.error('Clipboard API not supported')
  }
}

onMounted(() => {
  domainName.value = window.location.host
  store.items.length && emit('canGoToNextStep')
})
</script>